#-*- coding:utf-8 -*-
import json
import requests
import datetime
import logging
import time
import random
import string

class AkBigQuery:
    def __init__(self,queryInputJson,tripType,flightList,retFlights,fxRate):
        self.flightList = flightList
        self.retFlights = retFlights
        self.tripType = tripType
        self.queryInputJson = queryInputJson
        self.fxRate = fxRate
    def StartQuery(self):
        #开始执行时间
        salt = ''.join(random.sample(string.ascii_letters + string.digits, 16))+'|AKBIG'
        start = time.clock()
        queryUrl = 'http://128.14.29.226/spider/testsearch'
        headers = {'Content-Type': 'application/json'}
        fromJson = {}
        retJson = {}
        isOk = True
        session = requests.session()
        logging.info(salt+"|queryUrl："+queryUrl)
        logging.info(salt+"|tripType："+str(self.tripType))
        logging.info(salt+"|flightList："+str(self.flightList))
        logging.info(salt+"|retFlights："+str(self.retFlights))
        logging.info(salt+"|fxRate："+str(self.fxRate))
        logging.info(salt+"|queryInputJson："+str(self.queryInputJson))
        res = session.post(queryUrl, headers=headers, json=self.queryInputJson)
        #logging.info(salt+"|retJson："+res.text)
        print(res.text)
        json_str = json.loads(res.text)
        if 200 == json_str['status']:
            fromSegments = json_str['attachment']['fromSegments']
            for k in fromSegments:
                routeInfoEntities = k['routeInfoEntities']
                flightNumber = ''
                goOn = True
                for i in routeInfoEntities:
                    flightNumber += ','+i['flightNumber']
                    if i['flightNumber'] not in self.flightList:
                        goOn = False
                        break
                if goOn:
                    airlinePriceInfos = routeInfoEntities = k['airlinePriceInfos']
                    for i in airlinePriceInfos:
                        typsJson = {}
                        typsJson['currency'] = 'CNY'
                        typsJson['cabin'] = i['cabin']
                        typsJson['cabinName'] = i['cabinName']
                        if k['currency'] == 'CNY':
                            typsJson['adultPrice'] = i['adultPrice']
                            typsJson['adultTax'] = i['adultTax']
                            typsJson['priceTotal'] = round(i['adultPrice']+i['adultTax'],2)
                        else:
                            typsJson['adultPrice'] = round(i['adultPrice']*self.fxRate,2)
                            typsJson['adultTax'] = round(i['adultTax']*self.fxRate,2)
                            typsJson['priceTotal'] = round((i['adultPrice']+i['adultTax'])*self.fxRate,2)
                        typsJson['radioValue'] = ''
                        if i['cabin'] in fromJson.keys():
                            if fromJson[i['cabin']]['priceTotal'] > typsJson['priceTotal']:
                                fromJson[i['cabin']] =  typsJson
                        else:
                            fromJson[i['cabin']] =  typsJson
                    break
            if 2 == self.tripType:
                retSegments = json_str['attachment']['retSegments']
                for k in retSegments:
                    routeInfoEntities = k['routeInfoEntities']
                    flightNumber = ''
                    goOn = True
                    for i in routeInfoEntities:
                        flightNumber += ','+i['flightNumber']
                        if i['flightNumber'] not in self.retFlights:
                            goOn = False
                            break
                    if goOn:
                        airlinePriceInfos = routeInfoEntities = k['airlinePriceInfos']
                        for i in airlinePriceInfos:
                            typsJson = {}
                            typsJson['currency'] = 'CNY'
                            typsJson['cabin'] = i['cabin']
                            typsJson['cabinName'] = i['cabinName']
                            if k['currency'] == 'CNY':
                                typsJson['adultPrice'] = i['adultPrice']
                                typsJson['adultTax'] = i['adultTax']
                                typsJson['priceTotal'] = round(i['adultPrice']+i['adultTax'],2)
                            else:
                                typsJson['adultPrice'] = round(i['adultPrice']*self.fxRate,2)
                                typsJson['adultTax'] = round(i['adultTax']*self.fxRate,2)
                                typsJson['priceTotal'] = round((i['adultPrice']+i['adultTax'])*self.fxRate,2)
                            typsJson['radioValue'] = ''
                            if i['cabin'] in fromJson.keys():
                                if fromJson[i['cabin']]['priceTotal'] > typsJson['priceTotal']:
                                    retJson[i['cabin']] =  typsJson
                            else:
                                retJson[i['cabin']] =  typsJson
                        break
        else:
            isOk =False
        end = time.clock()
        logging.info(salt+"|isOk："+str(isOk))
        logging.info(salt+"|fromJson："+str(fromJson))
        logging.info(salt+"|retJson："+str(retJson))
        logging.info(salt+"|read: %f s" % (end - start))
        return (fromJson,retJson,isOk)
if __name__ == '__main__':
    
#     aaa = {}
#     
#     aaa['EC'] = 123456
#     if 'EP' in aaa.keys():
#         aaa['EC'] = 258741
#     
#     print(aaa)
    
    begin = datetime.datetime.now()    
    queryInputJson = {"airSource":"AK_BIG_APP","adultNum":1,"childNum":0,"formCity":"KUL","fromDate":"2018-05-13","id":0,"retDate":"","toCity":"CKG","tripType":"1","uuid":"AKBing","currency":"MYR"}
    flightList = 'D7808'
    retFlights = 'AK303'
    akbig = AkBigQuery(queryInputJson,1,flightList,retFlights,1)
    fromQueryJson,retQuerJson,isOk = akbig.StartQuery()
    print(fromQueryJson)
    print(retQuerJson)
         
    end = datetime.datetime.now()
    k = end - begin
    print(k.total_seconds())
        