#-*- coding:utf-8 -*-
import requests
import json
from entity.OrderInfo import Currency

import logging
import random
import string

class CallbackOrderUtils():
    
    callbackurl = "http://123.103.51.83/mgr/"
    #callbackurl = "http://192.168.1.5:11009/"
    
    def __init__(self):
        self.salt = ''.join(random.sample(string.ascii_letters + string.digits, 16))+'|'
    #回调占座结果
    def BallbackOrder(self,orderNo,orderStatus,orderPnr,accountType,userName):
        url = self.callbackurl+"orOrdertb/orderCallBack"
        self.salt = orderNo+'|'
        fromParam = {}
        fromParam['orderNo'] = orderNo
        fromParam['orderStatus'] = orderStatus
        fromParam['orderPnr'] = orderPnr
        fromParam['accountType'] = accountType
        fromParam['userName'] = userName
        session = requests.session()
        logging.info(self.salt+'回调占座结果:'+url)
        logging.info(self.salt+str(fromParam))
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
    #回调占座结果 刷单回调
    def brushOrderCallBack(self,orderNo,orderStatus,orderPnr,accountType,userName,passengerIds):
        url = self.callbackurl+"orOrdertb/brushOrderCallBack"
        self.salt = orderNo+'|'
        fromParam = {}
        fromParam['orderNo'] = orderNo
        fromParam['orderStatus'] = orderStatus
        fromParam['orderPnr'] = orderPnr
        fromParam['accountType'] = accountType
        fromParam['userName'] = userName
        fromParam['passengerIds'] = str(passengerIds)
        session = requests.session()
        logging.info(self.salt+'回调占座结果:'+url)
        logging.info(self.salt+str(fromParam))
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
    #回调价格
    def BallbackPrice(self,orderNo,webPriceGo,webPriceBack,agentPriceGo,agentPriceBack,bigPriceGo,bigPriceBack,sign):
        url = self.callbackurl+"orOrdertb/ballbackPrice"
        self.salt = orderNo+'|'
        fromParam = {}
        fromParam['orderNo'] = orderNo
        fromParam['webPrice'] = str({'go':webPriceGo,'back':webPriceBack})
        fromParam['agentPrice'] = str({'go':agentPriceGo,'back':agentPriceBack})
        fromParam['bigPrice'] = str({'go':bigPriceGo,'back':bigPriceBack})
        fromParam['sign'] = sign
        logging.info(self.salt+'价格回调：'+url)
        logging.info(self.salt+str(fromParam))
        session = requests.session()
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
    #通过机场三字码查询币种与汇率
    def cityToCurrency(self,stationCode):
        url = self.callbackurl+"scCitycurrency/cityToCurrency"
        fromParam = {}
        fromParam['stationCode'] = stationCode
        session = requests.session()
        logging.info(self.salt+url)
        logging.info(self.salt+str(fromParam))
        res = session.post(url,data=fromParam)
        logging.info(self.salt+res.text)
        json_str = json.loads(res.text)
        if 200 == json_str['status']:
            json_str = json_str['attachment']
            currency = Currency()
            currency.stationCode = json_str['stationCode']                  #机场三字码
            currency.currencyCode = json_str['currencyCode']                #币种
            currency.exchangeCode = json_str['exchangeCode']                #转化币种 一般为CNY
            currency.countryCode = json_str['countryCode']                  #城市编码
            currency.UnionPayOriginRate = json_str['UnionPayOriginRate']    #银联原始汇率
            currency.UnionPayFinalRate = json_str['UnionPayFinalRate']      #银联调整后汇率
            currency.AkOriginRate = json_str['AkOriginRate']                #亚航原始汇率
            currency.AkFinalRate = json_str['AkFinalRate']                  #亚航调整后汇率
            return currency
        return
    #获取代理IP
    def getProxyIP(self):
        session = requests.session()
        res = session.get('http://ip.16yun.cn:817/myip/pl/80b253ff-ac4c-428c-9a09-4a1c86d8705a/?s=jvqtmlwsjg&u=laopeng')
        ip = res.text.split('\n')[0]
        #print(ip)
        return ip.strip()
    #获取固定代理
    def getProxyFixedIP(self):
        ipList = ['pc316w:pc316w@182.84.98.201:888','pc316w:pc316w@120.210.207.98:888','pc316w:pc316w@120.210.206.100:888','pc316w:pc316w@222.186.11.27:888','pc316w:pc316w@222.186.11.201:888','pc316w:pc316w@117.41.184.193:888','pc316w:pc316w@1.82.230.118:888','pc316w:pc316w@222.73.129.182:888','pc316w:pc316w@222.186.139.222:888','pc316w:pc316w@103.21.141.83:888','pc316w:pc316w@120.210.206.180:888','pc316w:pc316w@27.54.242.197:888','pc316w:pc316w@27.54.210.197:888','pc316w:pc316w@210.16.180.254:888','pc316w:pc316w@210.16.187.119:888','pc316w:pc316w@58.221.62.224:888','pc316w:pc316w@180.153.90.217:888','pc316w:pc316w@120.79.163.168:888','pc316w:pc316w@47.94.110.70:888','pc316w:pc316w@101.226.179.96:888']
        return ipList[random.randint(0,19)]
        
if __name__ == '__main__':
    cout = CallbackOrderUtils()
    #cout.BallbackOrder('2018030915450779734174620', '1', 'YUNIHJ', '代理人占座', 'CNTRIPTOPK_ADMIN')
    #currency = cout.cityToCurrency('CAN')
    #print(currency.currencyCode)
    #ip = cout.getProxyIP()
    #print('----'+ip+'-----')
#     print(cout.getProxyFixedIP())
#     print(cout.getProxyFixedIP())
#     print(cout.getProxyFixedIP())
#     print(cout.getProxyFixedIP())
#     print(cout.getProxyFixedIP())
#     print(cout.getProxyFixedIP())

    #print(cout.getProxyIP())

    cout.brushOrderCallBack('903970518245', '1', 'JJQRRF', '代理人占座', 'CNTRIPTOPK_ADMIN', ['2679', '2680', '2681', '2682'])
    
#     orderNo = '903970518245'
#     webPriceGo = {}
#     webPriceBack = {}
#     agentPriceGo = {'EP': {'currency': 'CNY', 'cabin': 'EP', 'cabinName': '低航费', 'adultPrice': 788.0, 'adultTax': 0.0, 'priceTotal': 788.0, 'radioValue': '0~Z~~Z01H00H~AAX1~~196~X|D7~ 327~ ~~CTU~04/30/2018 23:55~KUL~05/01/2018 04:35~@04/30/2018 15:55:00'}, 'HF': {'currency': 'CNY', 'cabin': 'HF', 'cabinName': '常飞客', 'adultPrice': 1389.0, 'adultTax': 0.0, 'priceTotal': 1389.0, 'radioValue': '0~ZF~~ZF1F00~AAX1~~175~X|D7~ 327~ ~~CTU~04/30/2018 23:55~KUL~05/01/2018 04:35~@04/30/2018 15:55:00'}, 'PM': {'currency': 'CNY', 'cabin': 'PM', 'cabinName': '豪华平躺', 'adultPrice': 3898.0, 'adultTax': 0.0, 'priceTotal': 3898.0, 'radioValue': '0~J~~J01H00~AAX1~~197~X|D7~ 327~ ~~CTU~04/30/2018 23:55~KUL~05/01/2018 04:35~@04/30/2018 15:55:00'}}
#     agentPriceBack = {'EP': {'currency': 'CNY', 'cabin': 'EP', 'cabinName': '低航费', 'adultPrice': 787.68, 'adultTax': 0.0, 'priceTotal': 787.68, 'radioValue': '0~Z~~Z01H00H~AAX1~~196~X|D7~ 320~ ~~KUL~05/05/2018 09:10~CTU~05/05/2018 13:40~@05/5/2018 01:10:00'}, 'HF': {'currency': 'CNY', 'cabin': 'HF', 'cabinName': '常飞客', 'adultPrice': 1388.68, 'adultTax': 0.0, 'priceTotal': 1388.68, 'radioValue': '0~ZF~~ZF1F00~AAX1~~175~X|D7~ 320~ ~~KUL~05/05/2018 09:10~CTU~05/05/2018 13:40~@05/5/2018 01:10:00'}, 'PM': {'currency': 'CNY', 'cabin': 'PM', 'cabinName': '豪华平躺', 'adultPrice': 2897.68, 'adultTax': 0.0, 'priceTotal': 2897.68, 'radioValue': '0~C~~C01H00~AAX1~~195~X|D7~ 320~ ~~KUL~05/05/2018 09:10~CTU~05/05/2018 13:40~@05/5/2018 01:10:00'}}
#     bigPriceGo = {'EC': {'currency': 'CNY', 'cabin': 'EC', 'cabinName': '低航费', 'adultPrice': 698.01, 'adultTax': 90, 'priceTotal': 788.01, 'radioValue': ''}, 'HF': {'currency': 'CNY', 'cabin': 'HF', 'cabinName': '常飞客', 'adultPrice': 1299.0, 'adultTax': 90, 'priceTotal': 1389.0, 'radioValue': ''}, 'PM': {'currency': 'CNY', 'cabin': 'PM', 'cabinName': '豪华平躺座椅', 'adultPrice': 3808.0, 'adultTax': 90, 'priceTotal': 3898.0, 'radioValue': ''}} 
#     bigPriceBack = {'EC': {'currency': 'CNY', 'cabin': 'EC', 'cabinName': '低航费', 'adultPrice': 698.01, 'adultTax': 89.68, 'priceTotal': 787.69, 'radioValue': ''}, 'HF': {'currency': 'CNY', 'cabin': 'HF', 'cabinName': '常飞客', 'adultPrice': 1299.0, 'adultTax': 89.68, 'priceTotal': 1388.68, 'radioValue': ''}, 'PM': {'currency': 'CNY', 'cabin': 'PM', 'cabinName': '豪华平躺座椅', 'adultPrice': 2808.01, 'adultTax': 89.68, 'priceTotal': 2897.69, 'radioValue': ''}}
#     sign = True
#     cout.BallbackPrice(orderNo, webPriceGo, webPriceBack, agentPriceGo, agentPriceBack, bigPriceGo, bigPriceBack, sign)
#     print('-----------------完毕')

    
    